/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 23 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned short __u16;
#line 26 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned int __u32;
#line 30 "include/uapi/asm-generic/int-ll64.h"
typedef unsigned long long __u64;
#line 15 "include/asm-generic/int-ll64.h"
typedef signed char s8;
#line 16 "include/asm-generic/int-ll64.h"
typedef unsigned char u8;
#line 19 "include/asm-generic/int-ll64.h"
typedef unsigned short u16;
#line 22 "include/asm-generic/int-ll64.h"
typedef unsigned int u32;
#line 14 "./include/uapi/asm-generic/posix_types.h"
typedef long __kernel_long_t;
#line 15 "./include/uapi/asm-generic/posix_types.h"
typedef unsigned long __kernel_ulong_t;
#line 71 "./include/uapi/asm-generic/posix_types.h"
typedef __kernel_ulong_t __kernel_size_t;
#line 72 "./include/uapi/asm-generic/posix_types.h"
typedef __kernel_long_t __kernel_ssize_t;
#line 87 "./include/uapi/asm-generic/posix_types.h"
typedef long long __kernel_loff_t;
#line 229 "include/linux/compiler.h"
struct kernel_symbol {
   unsigned long value ;
   char const   *name ;
};
#line 33 "include/linux/export.h"
struct module;
#line 18 "include/linux/types.h"
typedef unsigned short umode_t;
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 45 "include/linux/types.h"
typedef __kernel_loff_t loff_t;
#line 54 "include/linux/types.h"
typedef __kernel_size_t size_t;
#line 59 "include/linux/types.h"
typedef __kernel_ssize_t ssize_t;
#line 177 "include/linux/types.h"
struct __anonstruct_atomic_t_6 {
   int counter ;
};
#line 177 "include/linux/types.h"
typedef struct __anonstruct_atomic_t_6 atomic_t;
#line 182 "include/linux/types.h"
struct __anonstruct_atomic64_t_7 {
   long counter ;
};
#line 182 "include/linux/types.h"
typedef struct __anonstruct_atomic64_t_7 atomic64_t;
#line 183 "include/linux/types.h"
struct list_head {
   struct list_head *next ;
   struct list_head *prev ;
};
#line 188
struct hlist_node;
#line 192 "include/linux/types.h"
struct hlist_node {
   struct hlist_node *next ;
   struct hlist_node **pprev ;
};
#line 203 "include/linux/types.h"
struct callback_head {
   struct callback_head *next ;
   void (*func)(struct callback_head * ) ;
};
#line 15 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pgdval_t;
#line 16 "./arch/x86/include/asm/pgtable_64_types.h"
typedef unsigned long pgprotval_t;
#line 20 "./arch/x86/include/asm/pgtable_64_types.h"
struct pgprot {
   pgprotval_t pgprot ;
};
#line 218 "./arch/x86/include/asm/pgtable_types.h"
typedef struct pgprot pgprot_t;
#line 220 "./arch/x86/include/asm/pgtable_types.h"
struct __anonstruct_pgd_t_12 {
   pgdval_t pgd ;
};
#line 220 "./arch/x86/include/asm/pgtable_types.h"
typedef struct __anonstruct_pgd_t_12 pgd_t;
#line 372
struct file;
#line 385
struct seq_file;
#line 425
struct mm_struct;
#line 426
struct task_struct;
#line 427
struct cpumask;
#line 20 "./arch/x86/include/asm/spinlock_types.h"
struct qspinlock {
   atomic_t val ;
};
#line 33 "include/asm-generic/qspinlock_types.h"
typedef struct qspinlock arch_spinlock_t;
#line 131 "include/linux/init.h"
typedef void (*ctor_fn_t)(void);
#line 432 "include/linux/printk.h"
struct completion;
#line 687 "include/linux/list.h"
struct lockdep_map;
#line 328 "include/linux/bitmap.h"
struct bug_entry {
   int bug_addr_disp ;
   int file_disp ;
   unsigned short line ;
   unsigned short flags ;
};
#line 102 "include/linux/bug.h"
struct cpumask {
   unsigned long bits[128U] ;
};
#line 652 "include/linux/cpumask.h"
typedef struct cpumask *cpumask_var_t;
#line 23 "include/asm-generic/atomic-long.h"
typedef atomic64_t atomic_long_t;
#line 55 "include/linux/debug_locks.h"
struct stack_trace {
   unsigned int nr_entries ;
   unsigned int max_entries ;
   unsigned long *entries ;
   int skip ;
};
#line 28 "include/linux/stacktrace.h"
struct lockdep_subclass_key {
   char __one_byte ;
};
#line 53 "include/linux/lockdep.h"
struct lock_class_key {
   struct lockdep_subclass_key subkeys[8U] ;
};
#line 59 "include/linux/lockdep.h"
struct lock_class {
   struct list_head hash_entry ;
   struct list_head lock_entry ;
   struct lockdep_subclass_key *key ;
   unsigned int subclass ;
   unsigned int dep_gen_id ;
   unsigned long usage_mask ;
   struct stack_trace usage_traces[13U] ;
   struct list_head locks_after ;
   struct list_head locks_before ;
   unsigned int version ;
   unsigned long ops ;
   char const   *name ;
   int name_version ;
   unsigned long contention_point[4U] ;
   unsigned long contending_point[4U] ;
};
#line 144 "include/linux/lockdep.h"
struct lockdep_map {
   struct lock_class_key *key ;
   struct lock_class *class_cache[2U] ;
   char const   *name ;
   int cpu ;
   unsigned long ip ;
};
#line 546 "include/linux/lockdep.h"
struct raw_spinlock {
   arch_spinlock_t raw_lock ;
   unsigned int magic ;
   unsigned int owner_cpu ;
   void *owner ;
   struct lockdep_map dep_map ;
};
#line 32 "include/linux/spinlock_types.h"
typedef struct raw_spinlock raw_spinlock_t;
#line 33 "include/linux/spinlock_types.h"
struct __anonstruct____missing_field_name_31 {
   u8 __padding[24U] ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
union __anonunion____missing_field_name_30 {
   struct raw_spinlock rlock ;
   struct __anonstruct____missing_field_name_31 __annonCompField16 ;
};
#line 33 "include/linux/spinlock_types.h"
struct spinlock {
   union __anonunion____missing_field_name_30 __annonCompField17 ;
};
#line 76 "include/linux/spinlock_types.h"
typedef struct spinlock spinlock_t;
#line 13 "include/linux/osq_lock.h"
struct optimistic_spin_queue {
   atomic_t tail ;
};
#line 39 "include/linux/osq_lock.h"
struct mutex {
   atomic_t count ;
   spinlock_t wait_lock ;
   struct list_head wait_list ;
   struct task_struct *owner ;
   void *magic ;
   struct lockdep_map dep_map ;
};
#line 36 "include/linux/stat.h"
struct vm_area_struct;
#line 38 "include/linux/wait.h"
struct __wait_queue_head {
   spinlock_t lock ;
   struct list_head task_list ;
};
#line 43 "include/linux/wait.h"
typedef struct __wait_queue_head wait_queue_head_t;
#line 796 "include/linux/mmzone.h"
struct rw_semaphore;
#line 797 "include/linux/mmzone.h"
struct rw_semaphore {
   long count ;
   struct list_head wait_list ;
   raw_spinlock_t wait_lock ;
   struct optimistic_spin_queue osq ;
   struct task_struct *owner ;
   struct lockdep_map dep_map ;
};
#line 172 "include/linux/rwsem.h"
struct completion {
   unsigned int done ;
   wait_queue_head_t wait ;
};
#line 1121 "include/linux/rcupdate.h"
struct timer_list {
   struct hlist_node entry ;
   unsigned long expires ;
   void (*function)(unsigned long  ) ;
   unsigned long data ;
   u32 flags ;
   int slack ;
   int start_pid ;
   void *start_site ;
   char start_comm[16U] ;
   struct lockdep_map lockdep_map ;
};
#line 240 "include/linux/timer.h"
struct rb_node {
   unsigned long __rb_parent_color ;
   struct rb_node *rb_right ;
   struct rb_node *rb_left ;
};
#line 41 "include/linux/rbtree.h"
struct rb_root {
   struct rb_node *rb_node ;
};
#line 259 "include/linux/timer.h"
struct workqueue_struct;
#line 260
struct work_struct;
#line 54 "include/linux/workqueue.h"
struct work_struct {
   atomic_long_t data ;
   struct list_head entry ;
   void (*func)(struct work_struct * ) ;
   struct lockdep_map lockdep_map ;
};
#line 107 "include/linux/workqueue.h"
struct delayed_work {
   struct work_struct work ;
   struct timer_list timer ;
   struct workqueue_struct *wq ;
   int cpu ;
};
#line 24 "./arch/x86/include/asm/mmu.h"
struct __anonstruct_mm_context_t_115 {
   void *ldt ;
   int size ;
   unsigned short ia32_compat ;
   struct mutex lock ;
   void *vdso ;
   atomic_t perf_rdpmc_allowed ;
};
#line 24 "./arch/x86/include/asm/mmu.h"
typedef struct __anonstruct_mm_context_t_115 mm_context_t;
#line 94 "include/linux/uprobes.h"
struct xol_area;
#line 95 "include/linux/uprobes.h"
struct uprobes_state {
   struct xol_area *xol_area ;
};
#line 266 "include/linux/mm_types.h"
struct __anonstruct_shared_161 {
   struct rb_node rb ;
   unsigned long rb_subtree_last ;
};
#line 266
struct anon_vma;
#line 266
struct vm_operations_struct;
#line 266
struct mempolicy;
#line 266 "include/linux/mm_types.h"
struct vm_area_struct {
   unsigned long vm_start ;
   unsigned long vm_end ;
   struct vm_area_struct *vm_next ;
   struct vm_area_struct *vm_prev ;
   struct rb_node vm_rb ;
   unsigned long rb_subtree_gap ;
   struct mm_struct *vm_mm ;
   pgprot_t vm_page_prot ;
   unsigned long vm_flags ;
   struct __anonstruct_shared_161 shared ;
   struct list_head anon_vma_chain ;
   struct anon_vma *anon_vma ;
   struct vm_operations_struct  const  *vm_ops ;
   unsigned long vm_pgoff ;
   struct file *vm_file ;
   void *vm_private_data ;
   struct mempolicy *vm_policy ;
};
#line 334 "include/linux/mm_types.h"
struct core_thread {
   struct task_struct *task ;
   struct core_thread *next ;
};
#line 340 "include/linux/mm_types.h"
struct core_state {
   atomic_t nr_threads ;
   struct core_thread dumper ;
   struct completion startup ;
};
#line 361 "include/linux/mm_types.h"
struct mm_rss_stat {
   atomic_long_t count[3U] ;
};
#line 366
struct kioctx_table;
#line 367
struct linux_binfmt;
#line 367
struct mmu_notifier_mm;
#line 367 "include/linux/mm_types.h"
struct mm_struct {
   struct vm_area_struct *mmap ;
   struct rb_root mm_rb ;
   u32 vmacache_seqnum ;
   unsigned long (*get_unmapped_area)(struct file * , unsigned long  , unsigned long  ,
                                      unsigned long  , unsigned long  ) ;
   unsigned long mmap_base ;
   unsigned long mmap_legacy_base ;
   unsigned long task_size ;
   unsigned long highest_vm_end ;
   pgd_t *pgd ;
   atomic_t mm_users ;
   atomic_t mm_count ;
   atomic_long_t nr_ptes ;
   atomic_long_t nr_pmds ;
   int map_count ;
   spinlock_t page_table_lock ;
   struct rw_semaphore mmap_sem ;
   struct list_head mmlist ;
   unsigned long hiwater_rss ;
   unsigned long hiwater_vm ;
   unsigned long total_vm ;
   unsigned long locked_vm ;
   unsigned long pinned_vm ;
   unsigned long shared_vm ;
   unsigned long exec_vm ;
   unsigned long stack_vm ;
   unsigned long def_flags ;
   unsigned long start_code ;
   unsigned long end_code ;
   unsigned long start_data ;
   unsigned long end_data ;
   unsigned long start_brk ;
   unsigned long brk ;
   unsigned long start_stack ;
   unsigned long arg_start ;
   unsigned long arg_end ;
   unsigned long env_start ;
   unsigned long env_end ;
   unsigned long saved_auxv[46U] ;
   struct mm_rss_stat rss_stat ;
   struct linux_binfmt *binfmt ;
   cpumask_var_t cpu_vm_mask_var ;
   mm_context_t context ;
   unsigned long flags ;
   struct core_state *core_state ;
   spinlock_t ioctx_lock ;
   struct kioctx_table *ioctx_table ;
   struct task_struct *owner ;
   struct file *exe_file ;
   struct mmu_notifier_mm *mmu_notifier_mm ;
   struct cpumask cpumask_allocation ;
   unsigned long numa_next_scan ;
   unsigned long numa_scan_offset ;
   int numa_scan_seq ;
   bool tlb_flush_pending ;
   struct uprobes_state uprobes_state ;
   void *bd_addr ;
};
#line 15 "include/uapi/linux/elf.h"
typedef __u64 Elf64_Addr;
#line 16 "include/uapi/linux/elf.h"
typedef __u16 Elf64_Half;
#line 20 "include/uapi/linux/elf.h"
typedef __u32 Elf64_Word;
#line 21 "include/uapi/linux/elf.h"
typedef __u64 Elf64_Xword;
#line 190 "include/uapi/linux/elf.h"
struct elf64_sym {
   Elf64_Word st_name ;
   unsigned char st_info ;
   unsigned char st_other ;
   Elf64_Half st_shndx ;
   Elf64_Addr st_value ;
   Elf64_Xword st_size ;
};
#line 198 "include/uapi/linux/elf.h"
typedef struct elf64_sym Elf64_Sym;
#line 53 "include/linux/elf.h"
union __anonunion____missing_field_name_166 {
   unsigned long bitmap[4U] ;
   struct callback_head callback_head ;
};
#line 53 "include/linux/elf.h"
struct idr_layer {
   int prefix ;
   int layer ;
   struct idr_layer *ary[256U] ;
   int count ;
   union __anonunion____missing_field_name_166 __annonCompField47 ;
};
#line 41 "include/linux/idr.h"
struct idr {
   struct idr_layer *hint ;
   struct idr_layer *top ;
   int layers ;
   int cur ;
   spinlock_t lock ;
   int id_free_cnt ;
   struct idr_layer *id_free ;
};
#line 124 "include/linux/idr.h"
struct ida_bitmap {
   long nr_busy ;
   unsigned long bitmap[15U] ;
};
#line 153 "include/linux/idr.h"
struct ida {
   struct idr idr ;
   struct ida_bitmap *free_bitmap ;
};
#line 189
struct kernfs_open_node;
#line 190
struct kernfs_iattrs;
#line 213
struct kernfs_root;
#line 213 "include/linux/idr.h"
struct kernfs_elem_dir {
   unsigned long subdirs ;
   struct rb_root children ;
   struct kernfs_root *root ;
};
#line 85 "include/linux/kernfs.h"
struct kernfs_node;
#line 85 "include/linux/kernfs.h"
struct kernfs_elem_symlink {
   struct kernfs_node *target_kn ;
};
#line 89
struct kernfs_ops;
#line 89 "include/linux/kernfs.h"
struct kernfs_elem_attr {
   struct kernfs_ops  const  *ops ;
   struct kernfs_open_node *open ;
   loff_t size ;
   struct kernfs_node *notify_next ;
};
#line 96 "include/linux/kernfs.h"
union __anonunion____missing_field_name_171 {
   struct kernfs_elem_dir dir ;
   struct kernfs_elem_symlink symlink ;
   struct kernfs_elem_attr attr ;
};
#line 96 "include/linux/kernfs.h"
struct kernfs_node {
   atomic_t count ;
   atomic_t active ;
   struct lockdep_map dep_map ;
   struct kernfs_node *parent ;
   char const   *name ;
   struct rb_node rb ;
   void const   *ns ;
   unsigned int hash ;
   union __anonunion____missing_field_name_171 __annonCompField48 ;
   void *priv ;
   unsigned short flags ;
   umode_t mode ;
   unsigned int ino ;
   struct kernfs_iattrs *iattr ;
};
#line 138 "include/linux/kernfs.h"
struct kernfs_syscall_ops {
   int (*remount_fs)(struct kernfs_root * , int * , char * ) ;
   int (*show_options)(struct seq_file * , struct kernfs_root * ) ;
   int (*mkdir)(struct kernfs_node * , char const   * , umode_t  ) ;
   int (*rmdir)(struct kernfs_node * ) ;
   int (*rename)(struct kernfs_node * , struct kernfs_node * , char const   * ) ;
};
#line 155 "include/linux/kernfs.h"
struct kernfs_root {
   struct kernfs_node *kn ;
   unsigned int flags ;
   struct ida ino_ida ;
   struct kernfs_syscall_ops *syscall_ops ;
   struct list_head supers ;
   wait_queue_head_t deactivate_waitq ;
};
#line 171 "include/linux/kernfs.h"
struct kernfs_open_file {
   struct kernfs_node *kn ;
   struct file *file ;
   void *priv ;
   struct mutex mutex ;
   int event ;
   struct list_head list ;
   char *prealloc_buf ;
   size_t atomic_write_len ;
   bool mmapped ;
   struct vm_operations_struct  const  *vm_ops ;
};
#line 188 "include/linux/kernfs.h"
struct kernfs_ops {
   int (*seq_show)(struct seq_file * , void * ) ;
   void *(*seq_start)(struct seq_file * , loff_t * ) ;
   void *(*seq_next)(struct seq_file * , void * , loff_t * ) ;
   void (*seq_stop)(struct seq_file * , void * ) ;
   ssize_t (*read)(struct kernfs_open_file * , char * , size_t  , loff_t  ) ;
   size_t atomic_write_len ;
   bool prealloc ;
   ssize_t (*write)(struct kernfs_open_file * , char * , size_t  , loff_t  ) ;
   int (*mmap)(struct kernfs_open_file * , struct vm_area_struct * ) ;
   struct lock_class_key lockdep_key ;
};
#line 477
struct sock;
#line 478
struct kobject;
#line 479
enum kobj_ns_type {
    KOBJ_NS_TYPE_NONE = 0,
    KOBJ_NS_TYPE_NET = 1,
    KOBJ_NS_TYPES = 2
} ;
#line 485 "include/linux/kernfs.h"
struct kobj_ns_type_operations {
   enum kobj_ns_type type ;
   bool (*current_may_mount)(void) ;
   void *(*grab_current_ns)(void) ;
   void const   *(*netlink_ns)(struct sock * ) ;
   void const   *(*initial_ns)(void) ;
   void (*drop_ns)(void * ) ;
};
#line 60 "include/linux/kobject_ns.h"
struct attribute {
   char const   *name ;
   umode_t mode ;
   bool ignore_lockdep ;
   struct lock_class_key *key ;
   struct lock_class_key skey ;
};
#line 155 "include/linux/sysfs.h"
struct sysfs_ops {
   ssize_t (*show)(struct kobject * , struct attribute * , char * ) ;
   ssize_t (*store)(struct kobject * , struct attribute * , char const   * , size_t  ) ;
};
#line 509 "include/linux/sysfs.h"
struct kref {
   atomic_t refcount ;
};
#line 52 "include/linux/kobject.h"
struct kset;
#line 52
struct kobj_type;
#line 52 "include/linux/kobject.h"
struct kobject {
   char const   *name ;
   struct list_head entry ;
   struct kobject *parent ;
   struct kset *kset ;
   struct kobj_type *ktype ;
   struct kernfs_node *sd ;
   struct kref kref ;
   struct delayed_work release ;
   unsigned char state_initialized : 1 ;
   unsigned char state_in_sysfs : 1 ;
   unsigned char state_add_uevent_sent : 1 ;
   unsigned char state_remove_uevent_sent : 1 ;
   unsigned char uevent_suppress : 1 ;
};
#line 114 "include/linux/kobject.h"
struct kobj_type {
   void (*release)(struct kobject * ) ;
   struct sysfs_ops  const  *sysfs_ops ;
   struct attribute **default_attrs ;
   struct kobj_ns_type_operations  const  *(*child_ns_type)(struct kobject * ) ;
   void const   *(*namespace)(struct kobject * ) ;
};
#line 122 "include/linux/kobject.h"
struct kobj_uevent_env {
   char *argv[3U] ;
   char *envp[32U] ;
   int envp_idx ;
   char buf[2048U] ;
   int buflen ;
};
#line 130 "include/linux/kobject.h"
struct kset_uevent_ops {
   int (* const  filter)(struct kset * , struct kobject * ) ;
   char const   *(* const  name)(struct kset * , struct kobject * ) ;
   int (* const  uevent)(struct kset * , struct kobject * , struct kobj_uevent_env * ) ;
};
#line 147 "include/linux/kobject.h"
struct kset {
   struct list_head list ;
   spinlock_t list_lock ;
   struct kobject kobj ;
   struct kset_uevent_ops  const  *uevent_ops ;
};
#line 222
struct kernel_param;
#line 227 "include/linux/kobject.h"
struct kernel_param_ops {
   unsigned int flags ;
   int (*set)(char const   * , struct kernel_param  const  * ) ;
   int (*get)(char * , struct kernel_param  const  * ) ;
   void (*free)(void * ) ;
};
#line 62 "include/linux/moduleparam.h"
struct kparam_string;
#line 62
struct kparam_array;
#line 62 "include/linux/moduleparam.h"
union __anonunion____missing_field_name_172 {
   void *arg ;
   struct kparam_string  const  *str ;
   struct kparam_array  const  *arr ;
};
#line 62 "include/linux/moduleparam.h"
struct kernel_param {
   char const   *name ;
   struct module *mod ;
   struct kernel_param_ops  const  *ops ;
   u16 const   perm ;
   s8 level ;
   u8 flags ;
   union __anonunion____missing_field_name_172 __annonCompField49 ;
};
#line 83 "include/linux/moduleparam.h"
struct kparam_string {
   unsigned int maxlen ;
   char *string ;
};
#line 89 "include/linux/moduleparam.h"
struct kparam_array {
   unsigned int max ;
   unsigned int elemsize ;
   unsigned int *num ;
   struct kernel_param_ops  const  *ops ;
   void *elem ;
};
#line 469 "include/linux/moduleparam.h"
struct latch_tree_node {
   struct rb_node node[2U] ;
};
#line 211 "include/linux/rbtree_latch.h"
struct mod_arch_specific {

};
#line 37 "include/linux/module.h"
struct module_param_attrs;
#line 37 "include/linux/module.h"
struct module_kobject {
   struct kobject kobj ;
   struct module *mod ;
   struct kobject *drivers_dir ;
   struct module_param_attrs *mp ;
   struct completion *kobj_completion ;
};
#line 47 "include/linux/module.h"
struct module_attribute {
   struct attribute attr ;
   ssize_t (*show)(struct module_attribute * , struct module_kobject * , char * ) ;
   ssize_t (*store)(struct module_attribute * , struct module_kobject * , char const   * ,
                    size_t  ) ;
   void (*setup)(struct module * , char const   * ) ;
   int (*test)(struct module * ) ;
   void (*free)(struct module * ) ;
};
#line 73
struct exception_table_entry;
#line 206
enum module_state {
    MODULE_STATE_LIVE = 0,
    MODULE_STATE_COMING = 1,
    MODULE_STATE_GOING = 2,
    MODULE_STATE_UNFORMED = 3
} ;
#line 213 "include/linux/module.h"
struct mod_tree_node {
   struct module *mod ;
   struct latch_tree_node node ;
};
#line 220
struct module_sect_attrs;
#line 220
struct module_notes_attrs;
#line 220
struct tracepoint;
#line 220
struct trace_event_call;
#line 220
struct trace_enum_map;
#line 220 "include/linux/module.h"
struct module {
   enum module_state state ;
   struct list_head list ;
   char name[56U] ;
   struct module_kobject mkobj ;
   struct module_attribute *modinfo_attrs ;
   char const   *version ;
   char const   *srcversion ;
   struct kobject *holders_dir ;
   struct kernel_symbol  const  *syms ;
   unsigned long const   *crcs ;
   unsigned int num_syms ;
   struct mutex param_lock ;
   struct kernel_param *kp ;
   unsigned int num_kp ;
   unsigned int num_gpl_syms ;
   struct kernel_symbol  const  *gpl_syms ;
   unsigned long const   *gpl_crcs ;
   struct kernel_symbol  const  *unused_syms ;
   unsigned long const   *unused_crcs ;
   unsigned int num_unused_syms ;
   unsigned int num_unused_gpl_syms ;
   struct kernel_symbol  const  *unused_gpl_syms ;
   unsigned long const   *unused_gpl_crcs ;
   bool sig_ok ;
   bool async_probe_requested ;
   struct kernel_symbol  const  *gpl_future_syms ;
   unsigned long const   *gpl_future_crcs ;
   unsigned int num_gpl_future_syms ;
   unsigned int num_exentries ;
   struct exception_table_entry *extable ;
   int (*init)(void) ;
   void *module_init ;
   void *module_core ;
   unsigned int init_size ;
   unsigned int core_size ;
   unsigned int init_text_size ;
   unsigned int core_text_size ;
   struct mod_tree_node mtn_core ;
   struct mod_tree_node mtn_init ;
   unsigned int init_ro_size ;
   unsigned int core_ro_size ;
   struct mod_arch_specific arch ;
   unsigned int taints ;
   unsigned int num_bugs ;
   struct list_head bug_list ;
   struct bug_entry *bug_table ;
   Elf64_Sym *symtab ;
   Elf64_Sym *core_symtab ;
   unsigned int num_symtab ;
   unsigned int core_num_syms ;
   char *strtab ;
   char *core_strtab ;
   struct module_sect_attrs *sect_attrs ;
   struct module_notes_attrs *notes_attrs ;
   char *args ;
   void *percpu ;
   unsigned int percpu_size ;
   unsigned int num_tracepoints ;
   struct tracepoint * const  *tracepoints_ptrs ;
   unsigned int num_trace_bprintk_fmt ;
   char const   **trace_bprintk_fmt_start ;
   struct trace_event_call **trace_events ;
   unsigned int num_trace_events ;
   struct trace_enum_map **trace_enums ;
   unsigned int num_trace_enums ;
   bool klp_alive ;
   struct list_head source_list ;
   struct list_head target_list ;
   void (*exit)(void) ;
   atomic_t refcnt ;
   ctor_fn_t (**ctors)(void) ;
   unsigned int num_ctors ;
};
#line 54 "include/linux/delay.h"
struct pi_protocol;
#line 54 "include/linux/delay.h"
struct pi_adapter {
   struct pi_protocol *proto ;
   int port ;
   int mode ;
   int delay ;
   int devtype ;
   char *device ;
   int unit ;
   int saved_r0 ;
   int saved_r2 ;
   int reserved ;
   unsigned long private ;
   wait_queue_head_t parq ;
   void *pardev ;
   char *parname ;
   int claimed ;
   void (*claim_cont)(void) ;
};
#line 57 "/home/cluser/mutilin/launch/inst/current/envs/linux-4.2-rc1.tar.xz/linux-4.2-rc1/drivers/block/paride/paride.h"
typedef struct pi_adapter PIA;
#line 134 "/home/cluser/mutilin/launch/inst/current/envs/linux-4.2-rc1.tar.xz/linux-4.2-rc1/drivers/block/paride/paride.h"
struct pi_protocol {
   char name[8U] ;
   int index ;
   int max_mode ;
   int epp_first ;
   int default_delay ;
   int max_units ;
   void (*write_regr)(PIA * , int  , int  , int  ) ;
   int (*read_regr)(PIA * , int  , int  ) ;
   void (*write_block)(PIA * , char * , int  ) ;
   void (*read_block)(PIA * , char * , int  ) ;
   void (*connect)(PIA * ) ;
   void (*disconnect)(PIA * ) ;
   int (*test_port)(PIA * ) ;
   int (*probe_unit)(PIA * ) ;
   int (*test_proto)(PIA * , char * , int  ) ;
   void (*log_adapter)(PIA * , char * , int  ) ;
   int (*init_proto)(PIA * ) ;
   void (*release_proto)(PIA * ) ;
   struct module *owner ;
};
#line 164 "/home/cluser/mutilin/launch/inst/current/envs/linux-4.2-rc1.tar.xz/linux-4.2-rc1/drivers/block/paride/paride.h"
typedef struct pi_protocol PIP;
#line 33 "include/linux/export.h"
extern struct module __this_module ;
#line 142 "include/linux/printk.h"
extern int printk(char const   *  , ...) ;
#line 174 "include/linux/mutex.h"
extern void mutex_unlock(struct mutex * ) ;
#line 177
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) ;
#line 18 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.o.c.prepared"
extern void mutex_lock(struct mutex * ) ;
#line 21
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) ;
#line 26
void ldv_mutex_lock_lock(struct mutex *lock ) ;
#line 30
void ldv_mutex_unlock_lock(struct mutex *lock ) ;
#line 320 "./arch/x86/include/asm/io.h"
__inline static void outb(unsigned char value , int port ) 
{ 


  {
#line 320
  __asm__  volatile   ("outb %b0, %w1": : "a" (value), "Nd" (port));
#line 321
  return;
}
}
#line 320 "./arch/x86/include/asm/io.h"
__inline static unsigned char inb(int port ) 
{ 
  unsigned char value ;

  {
#line 320
  __asm__  volatile   ("inb %w1, %b0": "=a" (value): "Nd" (port));
#line 320
  return (value);
}
}
#line 8 "include/asm-generic/delay.h"
extern void __udelay(unsigned long  ) ;
#line 166 "/home/cluser/mutilin/launch/inst/current/envs/linux-4.2-rc1.tar.xz/linux-4.2-rc1/drivers/block/paride/paride.h"
extern int paride_register(PIP * ) ;
#line 167
extern void paride_unregister(PIP * ) ;
#line 41 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_write_regr(PIA *pi , int cont , int regr , int val ) 
{ 


  {
#line 43
  if (cont == 1) {
#line 43
    return;
  } else {

  }
#line 44
  outb(12, pi->port + 2);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 44
  outb((int )((unsigned char )regr), pi->port);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 44
  outb(4, pi->port + 2);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 44
  outb((int )((unsigned char )val), pi->port);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 44
  outb(5, pi->port + 2);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 44
  outb(0, pi->port);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 44
  outb(4, pi->port + 2);
#line 44
  if (pi->delay != 0) {
#line 44
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 45
  return;
}
}
#line 47 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static int fit2_read_regr(PIA *pi , int cont , int regr ) 
{ 
  int a ;
  int b ;
  int r ;
  unsigned char tmp ;
  unsigned char tmp___0 ;

  {
#line 51
  if (cont != 0) {
#line 52
    if (regr != 6) {
#line 52
      return (255);
    } else {

    }
#line 53
    r = 7;
  } else {
#line 54
    r = regr + 16;
  }
#line 56
  outb(12, pi->port + 2);
#line 56
  if (pi->delay != 0) {
#line 56
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 56
  outb((int )((unsigned char )r), pi->port);
#line 56
  if (pi->delay != 0) {
#line 56
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 56
  outb(4, pi->port + 2);
#line 56
  if (pi->delay != 0) {
#line 56
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 56
  outb(5, pi->port + 2);
#line 56
  if (pi->delay != 0) {
#line 56
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 57
  outb(0, pi->port);
#line 57
  if (pi->delay != 0) {
#line 57
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 57
  if (pi->delay != 0) {
#line 57
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 57
  tmp = inb(pi->port + 1);
#line 57
  a = (int )tmp;
#line 58
  outb(1, pi->port);
#line 58
  if (pi->delay != 0) {
#line 58
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 58
  if (pi->delay != 0) {
#line 58
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 58
  tmp___0 = inb(pi->port + 1);
#line 58
  b = (int )tmp___0;
#line 59
  outb(4, pi->port + 2);
#line 59
  if (pi->delay != 0) {
#line 59
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 61
  return (((a >> 4) & 15) | (b & 240));
}
}
#line 65 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_read_block(PIA *pi , char *buf , int count ) 
{ 
  int k ;
  int a ;
  int b ;
  int c ;
  int d ;
  unsigned char tmp ;
  unsigned char tmp___0 ;
  unsigned char tmp___1 ;
  unsigned char tmp___2 ;
  unsigned char tmp___3 ;
  unsigned char tmp___4 ;
  unsigned char tmp___5 ;
  unsigned char tmp___6 ;

  {
#line 69
  outb(12, pi->port + 2);
#line 69
  if (pi->delay != 0) {
#line 69
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 69
  outb(16, pi->port);
#line 69
  if (pi->delay != 0) {
#line 69
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 71
  k = 0;
#line 71
  goto ldv_16073;
  ldv_16072: 
#line 73
  outb(4, pi->port + 2);
#line 73
  if (pi->delay != 0) {
#line 73
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 73
  outb(5, pi->port + 2);
#line 73
  if (pi->delay != 0) {
#line 73
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 74
  outb(0, pi->port);
#line 74
  if (pi->delay != 0) {
#line 74
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 74
  if (pi->delay != 0) {
#line 74
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 74
  tmp = inb(pi->port + 1);
#line 74
  a = (int )tmp;
#line 74
  outb(1, pi->port);
#line 74
  if (pi->delay != 0) {
#line 74
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 74
  if (pi->delay != 0) {
#line 74
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 74
  tmp___0 = inb(pi->port + 1);
#line 74
  b = (int )tmp___0;
#line 75
  outb(3, pi->port);
#line 75
  if (pi->delay != 0) {
#line 75
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 75
  if (pi->delay != 0) {
#line 75
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 75
  tmp___1 = inb(pi->port + 1);
#line 75
  c = (int )tmp___1;
#line 75
  outb(2, pi->port);
#line 75
  if (pi->delay != 0) {
#line 75
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 75
  if (pi->delay != 0) {
#line 75
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 75
  tmp___2 = inb(pi->port + 1);
#line 75
  d = (int )tmp___2;
#line 76
  *(buf + (unsigned long )(k * 4)) = ((int )((char )(a >> 4)) & 15) | ((int )((char )b) & -16);
#line 77
  *(buf + ((unsigned long )(k * 4) + 1UL)) = ((int )((char )(d >> 4)) & 15) | ((int )((char )c) & -16);
#line 79
  outb(4, pi->port + 2);
#line 79
  if (pi->delay != 0) {
#line 79
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 79
  outb(5, pi->port + 2);
#line 79
  if (pi->delay != 0) {
#line 79
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 80
  if (pi->delay != 0) {
#line 80
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 80
  tmp___3 = inb(pi->port + 1);
#line 80
  a = (int )tmp___3;
#line 80
  outb(3, pi->port);
#line 80
  if (pi->delay != 0) {
#line 80
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 80
  if (pi->delay != 0) {
#line 80
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 80
  tmp___4 = inb(pi->port + 1);
#line 80
  b = (int )tmp___4;
#line 81
  outb(1, pi->port);
#line 81
  if (pi->delay != 0) {
#line 81
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 81
  if (pi->delay != 0) {
#line 81
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 81
  tmp___5 = inb(pi->port + 1);
#line 81
  c = (int )tmp___5;
#line 81
  outb(0, pi->port);
#line 81
  if (pi->delay != 0) {
#line 81
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 81
  if (pi->delay != 0) {
#line 81
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 81
  tmp___6 = inb(pi->port + 1);
#line 81
  d = (int )tmp___6;
#line 82
  *(buf + ((unsigned long )(k * 4) + 2UL)) = ((int )((char )(d >> 4)) & 15) | ((int )((char )c) & -16);
#line 83
  *(buf + ((unsigned long )(k * 4) + 3UL)) = ((int )((char )(a >> 4)) & 15) | ((int )((char )b) & -16);
#line 71
  k = k + 1;
  ldv_16073: ;
#line 71
  if (count / 4 > k) {
#line 73
    goto ldv_16072;
  } else {

  }
#line 87
  outb(4, pi->port + 2);
#line 87
  if (pi->delay != 0) {
#line 87
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 88
  return;
}
}
#line 91 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_write_block(PIA *pi , char *buf , int count ) 
{ 
  int k ;

  {
#line 96
  outb(12, pi->port + 2);
#line 96
  if (pi->delay != 0) {
#line 96
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 96
  outb(0, pi->port);
#line 96
  if (pi->delay != 0) {
#line 96
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 97
  k = 0;
#line 97
  goto ldv_16082;
  ldv_16081: 
#line 98
  outb(4, pi->port + 2);
#line 98
  if (pi->delay != 0) {
#line 98
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 98
  outb((int )((unsigned char )*(buf + (unsigned long )(k * 2))), pi->port);
#line 98
  if (pi->delay != 0) {
#line 98
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 99
  outb(5, pi->port + 2);
#line 99
  if (pi->delay != 0) {
#line 99
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 99
  outb((int )((unsigned char )*(buf + ((unsigned long )(k * 2) + 1UL))), pi->port);
#line 99
  if (pi->delay != 0) {
#line 99
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 97
  k = k + 1;
  ldv_16082: ;
#line 97
  if (count / 2 > k) {
#line 99
    goto ldv_16081;
  } else {

  }
#line 101
  outb(4, pi->port + 2);
#line 101
  if (pi->delay != 0) {
#line 101
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 102
  return;
}
}
#line 104 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_connect(PIA *pi ) 
{ 
  unsigned char tmp ;
  unsigned char tmp___0 ;

  {
#line 106
  if (pi->delay != 0) {
#line 106
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 106
  tmp = inb(pi->port);
#line 106
  pi->saved_r0 = (int )tmp;
#line 107
  if (pi->delay != 0) {
#line 107
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 107
  tmp___0 = inb(pi->port + 2);
#line 107
  pi->saved_r2 = (int )tmp___0;
#line 108
  outb(204, pi->port + 2);
#line 108
  if (pi->delay != 0) {
#line 108
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 109
  return;
}
}
#line 111 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_disconnect(PIA *pi ) 
{ 


  {
#line 113
  outb((int )((unsigned char )pi->saved_r0), pi->port);
#line 113
  if (pi->delay != 0) {
#line 113
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 114
  outb((int )((unsigned char )pi->saved_r2), pi->port + 2);
#line 114
  if (pi->delay != 0) {
#line 114
    __udelay((unsigned long )pi->delay);
  } else {

  }
#line 115
  return;
}
}
#line 117 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_log_adapter(PIA *pi , char *scratch , int verbose ) 
{ 


  {
#line 119
  printk("%s: fit2 %s, FIT 2000 adapter at 0x%x, delay %d\n", pi->device, (char *)"1.0",
         pi->port, pi->delay);
#line 121
  return;
}
}
#line 124 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static struct pi_protocol fit2  = 
#line 124
     {{'f', 'i', 't', '2', '\000'}, 0, 1, 2, 1, 1, & fit2_write_regr, & fit2_read_regr,
    & fit2_write_block, & fit2_read_block, & fit2_connect, & fit2_disconnect, 0, 0,
    0, & fit2_log_adapter, 0, 0, & __this_module};
#line 140 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static int fit2_init(void) 
{ 
  int tmp ;

  {
#line 142
  tmp = paride_register(& fit2);
#line 142
  return (tmp);
}
}
#line 145 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
static void fit2_exit(void) 
{ 


  {
#line 147
  paride_unregister(& fit2);
#line 148
  return;
}
}
#line 170
void ldv_check_final_state(void) ;
#line 179
extern void ldv_initialize(void) ;
#line 182
extern void ldv_handler_precall(void) ;
#line 185
extern int nondet_int(void) ;
#line 188 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
int LDV_IN_INTERRUPT  ;
#line 191 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.c"
void main(void) 
{ 
  PIA *var_fit2_write_regr_0_p0 ;
  int var_fit2_write_regr_0_p1 ;
  int var_fit2_write_regr_0_p2 ;
  int var_fit2_write_regr_0_p3 ;
  PIA *var_fit2_read_regr_1_p0 ;
  int var_fit2_read_regr_1_p1 ;
  int var_fit2_read_regr_1_p2 ;
  PIA *var_fit2_write_block_3_p0 ;
  char *var_fit2_write_block_3_p1 ;
  int var_fit2_write_block_3_p2 ;
  PIA *var_fit2_read_block_2_p0 ;
  char *var_fit2_read_block_2_p1 ;
  int var_fit2_read_block_2_p2 ;
  PIA *var_fit2_connect_4_p0 ;
  PIA *var_fit2_disconnect_5_p0 ;
  PIA *var_fit2_log_adapter_6_p0 ;
  char *var_fit2_log_adapter_6_p1 ;
  int var_fit2_log_adapter_6_p2 ;
  int ldv_s_fit2_pi_protocol ;
  int tmp ;
  int tmp___0 ;
  int tmp___1 ;

  {
#line 297
  ldv_s_fit2_pi_protocol = 0;
#line 276
  LDV_IN_INTERRUPT = 1;
#line 285
  ldv_initialize();
#line 294
  ldv_handler_precall();
#line 295
  tmp = fit2_init();
#line 295
  if (tmp != 0) {
#line 296
    goto ldv_final;
  } else {

  }
#line 301
  goto ldv_16159;
  ldv_16158: 
#line 305
  tmp___0 = nondet_int();
#line 305
  switch (tmp___0) {
  case 0: ;
#line 310
  if (ldv_s_fit2_pi_protocol == 0) {
#line 318
    ldv_handler_precall();
#line 319
    fit2_connect(var_fit2_connect_4_p0);
#line 320
    ldv_s_fit2_pi_protocol = ldv_s_fit2_pi_protocol + 1;
  } else {

  }
#line 326
  goto ldv_16150;
  case 1: ;
#line 330
  if (ldv_s_fit2_pi_protocol == 1) {
#line 338
    ldv_handler_precall();
#line 339
    fit2_disconnect(var_fit2_disconnect_5_p0);
#line 340
    ldv_s_fit2_pi_protocol = 0;
  } else {

  }
#line 346
  goto ldv_16150;
  case 2: 
#line 358
  ldv_handler_precall();
#line 359
  fit2_write_regr(var_fit2_write_regr_0_p0, var_fit2_write_regr_0_p1, var_fit2_write_regr_0_p2,
                  var_fit2_write_regr_0_p3);
#line 366
  goto ldv_16150;
  case 3: 
#line 378
  ldv_handler_precall();
#line 379
  fit2_read_regr(var_fit2_read_regr_1_p0, var_fit2_read_regr_1_p1, var_fit2_read_regr_1_p2);
#line 386
  goto ldv_16150;
  case 4: 
#line 398
  ldv_handler_precall();
#line 399
  fit2_write_block(var_fit2_write_block_3_p0, var_fit2_write_block_3_p1, var_fit2_write_block_3_p2);
#line 406
  goto ldv_16150;
  case 5: 
#line 418
  ldv_handler_precall();
#line 419
  fit2_read_block(var_fit2_read_block_2_p0, var_fit2_read_block_2_p1, var_fit2_read_block_2_p2);
#line 426
  goto ldv_16150;
  case 6: 
#line 438
  ldv_handler_precall();
#line 439
  fit2_log_adapter(var_fit2_log_adapter_6_p0, var_fit2_log_adapter_6_p1, var_fit2_log_adapter_6_p2);
#line 446
  goto ldv_16150;
  default: ;
#line 447
  goto ldv_16150;
  }
  ldv_16150: ;
  ldv_16159: 
#line 301
  tmp___1 = nondet_int();
#line 301
  if (tmp___1 != 0 || ldv_s_fit2_pi_protocol != 0) {
#line 304
    goto ldv_16158;
  } else {

  }

#line 462
  ldv_handler_precall();
#line 463
  fit2_exit();
  ldv_final: 
#line 466
  ldv_check_final_state();
#line 469
  return;
}
}
#line 57 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.o.c.prepared"
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 60
  ldv_mutex_lock_lock(ldv_func_arg1);
#line 62
  mutex_lock(ldv_func_arg1);
#line 63
  return;
}
}
#line 65 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/dscv/ri/32_7a/drivers/block/paride/fit2.o.c.prepared"
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 68
  ldv_mutex_unlock_lock(ldv_func_arg1);
#line 70
  mutex_unlock(ldv_func_arg1);
#line 71
  return;
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 20 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_stop(void) 
{ 


  {
  LDV_STOP: ;
#line 21
  goto LDV_STOP;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 30 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static int ldv_undef_int_negative(void) 
{ 
  int ret ;
  int tmp ;

  {
#line 32
  tmp = ldv_undef_int();
#line 32
  ret = tmp;
#line 34
  if (ret >= 0) {
#line 34
    ldv_stop();
  } else {

  }
#line 36
  return (ret);
}
}
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 8 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_lock  =    1;
#line 11 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 16
  if (ldv_mutex_lock != 1) {
#line 16
    ldv_error();
  } else {

  }
#line 19
  nondetermined = ldv_undef_int();
#line 22
  if (nondetermined != 0) {
#line 25
    ldv_mutex_lock = 2;
#line 27
    return (0);
  } else {
#line 32
    return (-4);
  }
}
}
#line 37 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 42
  if (ldv_mutex_lock != 1) {
#line 42
    ldv_error();
  } else {

  }
#line 45
  nondetermined = ldv_undef_int();
#line 48
  if (nondetermined != 0) {
#line 51
    ldv_mutex_lock = 2;
#line 53
    return (0);
  } else {
#line 58
    return (-4);
  }
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_lock(struct mutex *lock ) 
{ 


  {
#line 66
  if (ldv_mutex_lock != 1) {
#line 66
    ldv_error();
  } else {

  }
#line 68
  ldv_mutex_lock = 2;
#line 69
  return;
}
}
#line 72 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_lock(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 77
  if (ldv_mutex_lock != 1) {
#line 77
    ldv_error();
  } else {

  }
#line 80
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 83
  if (is_mutex_held_by_another_thread != 0) {
#line 86
    return (0);
  } else {
#line 91
    ldv_mutex_lock = 2;
#line 93
    return (1);
  }
}
}
#line 98 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_lock(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 103
  if (ldv_mutex_lock != 1) {
#line 103
    ldv_error();
  } else {

  }
#line 106
  atomic_value_after_dec = ldv_undef_int();
#line 109
  if (atomic_value_after_dec == 0) {
#line 112
    ldv_mutex_lock = 2;
#line 114
    return (1);
  } else {

  }
#line 118
  return (0);
}
}
#line 123 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 127
  if (ldv_mutex_lock == 1) {
#line 130
    nondetermined = ldv_undef_int();
#line 133
    if (nondetermined != 0) {
#line 136
      return (0);
    } else {
#line 141
      return (1);
    }
  } else {
#line 147
    return (1);
  }
}
}
#line 152 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_lock(struct mutex *lock ) 
{ 


  {
#line 155
  if (ldv_mutex_lock != 2) {
#line 155
    ldv_error();
  } else {

  }
#line 157
  ldv_mutex_lock = 1;
#line 158
  return;
}
}
#line 163 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_lock(void) 
{ 


  {
#line 166
  ldv_mutex_lock_lock((struct mutex *)0);
#line 167
  return;
}
}
#line 170 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_lock(void) 
{ 
  int tmp ;

  {
#line 172
  tmp = ldv_mutex_trylock_lock((struct mutex *)0);
#line 172
  return (tmp);
}
}
#line 176 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_lock(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 178
  tmp___0 = ldv_undef_int();
#line 178
  if (tmp___0 != 0) {
#line 180
    ldv_mutex_lock_lock((struct mutex *)0);
#line 182
    return (0);
  } else {
#line 185
    tmp = ldv_undef_int_negative();
#line 185
    return (tmp);
  }
}
}
#line 189 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_lock(void) 
{ 


  {
#line 191
  ldv_mutex_unlock_lock((struct mutex *)0);
#line 192
  return;
}
}
#line 196 "/home/cluser/mutilin/launch/work/current--X--drivers--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/10617/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_check_final_state(void) 
{ 


  {
#line 199
  if (ldv_mutex_lock != 1) {
#line 199
    ldv_error();
  } else {

  }
#line 203
  return;
}
}
